function h = H_KDE(data)
% Optimized entropy estimation based on a KDE using a multivariate Gaussian kernel.
%   data: (dim,samples) double array.
% 
% (c)2014 Andreas M. Lehrmann

[r,c]=size(data);
f = c^(-1/(4+r));
[vec,val] = eig(cov(data'));
[cd,flag] = chol(f^2*cov(data'));
if ~flag
    D = 1/c*sum(logsumexp(squareform(-0.5*pdistmex(data,'mah',cd\eye(r)).^2)));
    h = log(c*det(f*vec*sqrt(val)*vec')*(2*pi)^(r/2))-D;
else
    h=NaN;
end

end