function res = logsumwexp(data,weights)
% Robust computation of log(sum(w.*exp(data),2)).
%   data   : (observations, instances) double array.
%   weights: (observations, instances) double array.
%
% (c)2014 Andreas M. Lehrmann

m = max(data,[],2);
res = m+log(sum(weights.*exp(data-repmat(m,1,size(data,2))),2));

end