function [train,test] = split(data,ratio,subsample)
% Subsample data and split into train and test.
%   data     : (observations, dim) double array.
%   ratio    : Scalar double between 0 and 1. Ratio of train. 
%   subsample: Scalar double between 0 and 1. Subsampling rate.
%
% (c)2014 Andreas M. Lehrmann

n = randperm(size(data,1),round(subsample*size(data,1)));
i = round(ratio*length(n));
train = data(n(1:i),:);
test = data(n(i+1:end),:);

end