function ll = all(obj,input,exactClusters)
% Compute approximate log-likelihoods.
%   input        : (dim,samples) double array. The test data points.
%   exactClusters: Scalar integer between 1 and totalClusters.
%                  The number of exact clusters to use for the computation.
%
% (c)2014 Andreas M. Lehrmann

ll=zeros(length(obj.variables),size(input,2));
for j=1:length(obj.variables)
    cIndex = obj.ordering(j);
    pIndex = obj.variables(cIndex).parent;
    for i=1:size(input,2)  
        pData = [];
        if ~isempty(pIndex) pData = input(obj.variables(pIndex).channels,i);end
        ll(j,i) = obj.variables(cIndex).cpd.all(input(obj.variables(cIndex).channels,i),pData,exactClusters);
    end   
end

end