function ll = ll(obj,input)
% Compute exact log-likelihoods.
%   input: (dim,samples) double array. The test data points.
% 
% (c)2014 Andreas M. Lehrmann

data = cell(length(obj.variables),1);
for i=1:length(obj.variables)
    data{i} = input(obj.variables(i).channels,:);
end

ll = zeros(1,size(data{1},2));
for i=1:size(data{1},2)
    for j=1:length(data)        
        cIndex = obj.ordering(j);
        cData = data{cIndex};
        cData = cData(:,i);
        
        pIndex = obj.getPa(cIndex);
        if ~isempty(pIndex)
            pData = cell2mat(data(pIndex));
            pData = pData(:,i);
        else
            pData = [];
        end
        ll(i) = ll(i) + obj.variables(cIndex).cpd.ll(cData,pData);
    end   
end

end