function res = mst(obj,am,mode)
% Compute the minimum or maximum spanning tree of a connected graph (Prim's algorithm).
%   am  : (n,n) double array. An adjacency matrix.
%   mode: Possible values are {'min','max'} for minimum/maximum spanning trees.
%
% (c)2014 Andreas M. Lehrmann

N = size(am,1);
keys = 1:N;
values = [0 ones(1,N-1)*realmax];
parents = zeros(1,N);

pq = pq_create(N);
for i=1:N pq_push(pq,keys(i),-values(i));end
if strcmp(mode,'max')am=-am;end
while pq_size(pq)~=0
    id = pq_pop(pq);
    keys(id) = 0;
    for i=find(am(id,:))
        if keys(i)&&am(id,i)<values(i)
            parents(i) = id;
            values(i) = am(id,i);
            pq_push(pq,i,-values(i));
        end
    end
end
if strcmp(mode,'max')am=-am;end
pq_delete(pq);

res = zeros(size(am));
res(sub2ind([N,N],parents(2:N),2:N)) = am(sub2ind([N,N],parents(2:N),2:N));
res = res+res';

end