function samples = sample(obj,cases)
% Draw random samples from the Bayesian network.
%   cases: Scalar integer. The number of samples to draw.
% 
% (c)2014 Andreas M. Lehrmann

samples = zeros(cases,length([obj.variables.channels]));
for i=1:cases
    s = sampleHelper(obj,1,cell(length(obj.variables),1));
    for j=1:length(obj.variables)
        samples(i,obj.variables(j).channels) = s{j};
    end
end

end

function sample = sampleHelper(obj,step,sample)

cVar = obj.ordering(step);
cPa = obj.getPa(cVar);
[temp{1:length(cPa)}] = sample{cPa};
condition = cell2mat(temp)';
sample{cVar} = obj.variables(cVar).cpd.sample(condition);

if step<length(obj.ordering) 
    sample = sampleHelper(obj,step+1,sample);
end

end