function [result] = ll(obj, data, condition)
% Compute expected log-likelihood subject to a condition.
%   data     : (dim,samples) double array. The test data points.
%   condition: [] or (length(cond),1) double array. The condition.
% 
% (c)2014 Andreas M. Lehrmann

if nargin<3 condition=zeros(0,1);end
if ~isempty(condition)
    mu = obj.mu.static+obj.mu.dynamic*condition;
else
    mu = obj.mu;
end

result = 0;
for i=1:size(data,2)
    c = data(:,i)-mu;
    result = result + c'*obj.precision*c;
end
result = (size(data,2)*obj.llConstant-0.5*result)/size(data,2);

end