function ll = ll(obj, data, cond)
% A more efficient approach than llNaive to compute an exact log-likelihood.
%   data: (dim-length(pIndex),1) double array. The data point.
%   cond: [] or (length(pIndex),1) double array. The condition.
% 
% (c)2014 Andreas M. Lehrmann

if isempty(cond)
    ll = obj.constantStatic+logsumexp(-0.5*(sum((repmat(obj.LJ*data,1,obj.samples)-obj.PJ).^2)),2);
else
    joint = [data;cond];
    if strcmp(obj.best,'full')
        ll = obj.constantStatic-obj.constantDynamic + ...
             diff(logsumexp([-0.5*(sum((repmat(obj.LM*cond,1,obj.samples)-obj.PM).^2,1));
                             -0.5*(sum((repmat(obj.LJ*joint,1,obj.samples)-obj.PJ).^2,1))],2));
    else
        temp = (repmat(diag(obj.LJ).*joint,1,obj.samples)-obj.PJ).^2;
        ll = obj.constantStatic-obj.constantDynamic+diff(logsumexp([-0.5*sum(temp(obj.pIndex,:),1);-0.5*sum(temp,1)],2));
    end
end

end