clear
clc

lDisp('Testing approximate log-likelihoods...')
DATAPOINTS = 1000;
TOTALCLUSTERS = 40;
THRESH = 1e-10;

for i=[2 4 6]
    for j=[2 (i/2)+1 i]
        fprintf('[testAll]: Generating KDE with joint dimensionality %s and conditional dimensionality %s...\n',int2str(i),int2str(i-length(j:i)))
        k = KDE;
        data = mvnrnd(zeros(i,1),eye(i),DATAPOINTS)';
        k.estimate(data,j:i,[]);
        testPoint = rand(i,1);
        
        fprintf('[testAll]: Checking unconditional approximate log-likelihoods...')
        gt = k.llNaive(testPoint,[]);
        k.switchAll(1,TOTALCLUSTERS);
        approx1 = k.all(testPoint,[],TOTALCLUSTERS);
        k.switchAll(1,DATAPOINTS);
        approx2 = k.all(testPoint,[],1);
        if(abs(gt-approx1)<THRESH&&abs(gt-approx2)<THRESH) fprintf('passed.\n')
        else fprintf('failed (%d and %d)\n',abs(gt-approx1),abs(gt-approx2))
        end
        
        
        fprintf('[testAll]: Checking conditional approximate log-likelihoods...')
        gt = k.llNaive(testPoint(1:j-1),testPoint(j:i));
        k.switchAll(1,TOTALCLUSTERS);
        approx1 = k.all(testPoint(1:j-1),testPoint(j:i),TOTALCLUSTERS);   
        k.switchAll(1,DATAPOINTS);
        approx2 = k.all(testPoint(1:j-1),testPoint(j:i),1);
        if(abs(gt-approx1)<THRESH&&abs(gt-approx2)<THRESH) fprintf('passed.\n')
        else fprintf('failed (%d and %d)\n',abs(gt-approx1),abs(gt-approx2))
        end
    end
end